"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.connectMongoDb = exports.collections = void 0;
const mongodb_1 = require("mongodb");
const metadata_1 = require("../../global/metadata");
const commons_1 = require("../../commons");
exports.collections = {};
const connectMongoDb = (config, isTest) => __awaiter(void 0, void 0, void 0, function* () {
    try {
        const mongodb = new mongodb_1.MongoClient(config.MONGODB_HOST);
        yield mongodb.connect();
        const db = mongodb.db(config.MONGODB_DB);
        (0, metadata_1.getMetadataTable)().getAllTableName().forEach((name) => {
            exports.collections[name] = db.collection(name);
        });
        if (!isTest) {
            console.log("****************************");
            console.log("*    Starting Server");
            console.log(`*    ${(0, commons_1.csuccess)(`DB_URL: ${config.MONGODB_HOST}, DB:${config.MONGODB_DB}`)}`);
            console.log(`*    ${(0, commons_1.csuccess)(`Port: ${config.PORT}`)}`);
            console.log(`*    ${(0, commons_1.csuccess)(`NODE_ENV: ${config.ENV}`)}`);
            console.log(`*    ${(0, commons_1.csuccess)("Database: MongoDB")}`);
            console.log(`*    ${(0, commons_1.csuccess)("DB Connection: OK")}`);
            console.log(`****************************`);
        }
        return db;
    }
    catch (error) {
        console.log(`*    ${(0, commons_1.cerror)(`Error connecting to DB: ${error}\n****************************`)}\n`);
        process.exit();
    }
});
exports.connectMongoDb = connectMongoDb;
