import { ObjectId } from "mongodb";
import { QueryCondition } from "../../queryBuilder/interfaces/QueryCondition";
export type QueriesNumber = {
    min?: number;
    max?: number;
    isMinExclusive?: boolean;
    isMaxExclusive?: boolean;
};
export type QueriesString = {
    value: string;
    isAbsolute?: boolean;
};
export type IQueries<T> = {
    [K in keyof T]?: T[K] extends ObjectId ? string[] : T[K] | (T[K] extends number ? QueriesNumber : QueriesString);
};
export interface ExpandItem {
    model: string;
    filter?: QueryCondition<any>;
    with?: ExpandItem[];
}
export interface ExpandItemFilterString {
    model: string;
    filter?: string;
    with?: ExpandItemFilterString[];
}
