"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.compareDBMetadata = exports.generateDBMetadata = void 0;
const metadata_1 = require("../../global/metadata");
const fs = __importStar(require("fs"));
const child_process_1 = require("child_process");
const path = __importStar(require("path"));
const fs_1 = require("fs");
var TypeDB;
(function (TypeDB) {
    TypeDB["MONGO"] = "mongodb";
    TypeDB["MYSQL"] = "mysql";
})(TypeDB || (TypeDB = {}));
const rootPath = path.dirname(require.main.filename);
const getMetadata = () => __awaiter(void 0, void 0, void 0, function* () {
    const metadataTable = [];
    (0, metadata_1.getMetadataTable)().getTables().forEach((table) => {
        const metaTmp = {
            name: table.name,
            type: TypeDB.MONGO,
            columns: [],
            relations: [],
        };
        metaTmp.columns = table.columns.map((column) => {
            column.type = column.type.name;
            return column;
        });
        metaTmp.relations = table.relations.map((relation) => {
            return {
                fieldName: relation.fieldName,
                type: relation.type,
                sync: relation.sync || false,
                refs: {
                    modelChild: relation.refs.modelChild().name,
                    modelParent: relation.refs.modelParent().name,
                    FK: relation.refs.FK,
                    PK: relation.refs.PK
                }
            };
        });
        metadataTable.push(metaTmp);
    });
    return metadataTable;
});
const generateDBMetadata = () => __awaiter(void 0, void 0, void 0, function* () {
    const metadataTable = yield getMetadata();
    const outputFile = "./metadata.json";
    yield new Promise((resolve, reject) => {
        fs.writeFile(outputFile, JSON.stringify(metadataTable), "utf8", (err) => {
            if (err) {
                reject(err);
                return;
            }
            // file written successfully
            (0, child_process_1.exec)(`npx prettier --write ${outputFile}`, (err) => {
                if (err) {
                    reject(err);
                    return;
                }
                console.log("success");
                resolve(1);
            });
        });
    });
});
exports.generateDBMetadata = generateDBMetadata;
const compareDBMetadata = () => __awaiter(void 0, void 0, void 0, function* () {
    const pathDocJson = rootPath + "/metadata.json";
    if ((0, fs_1.existsSync)(pathDocJson)) {
        console.log("true");
        const metadataTable = yield getMetadata();
        const metaOld = require(pathDocJson);
        console.log(metaOld, metadataTable);
    }
    else {
        console.log("file not exist");
    }
});
exports.compareDBMetadata = compareDBMetadata;
