"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.injectorResponse = void 0;
const commons_1 = require("../commons");
const injectorResponse = (req, res, next, config) => __awaiter(void 0, void 0, void 0, function* () {
    const reqObject = {
        headers: req.headers,
        url: req.url,
        method: req.method,
        params: req.params,
        query: req.query,
        body: req.body
    };
    // Create a new send method
    res.broadcast = function (data) {
        var _a, _b, _c, _d;
        res.send(data);
        if (res.statusCode < 400) {
            (_a = config._logger) === null || _a === void 0 ? void 0 : _a.info(`\nREQUEST: ${JSON.stringify(reqObject)}\nRESPONSE DATA: ${JSON.stringify(data)}\n`);
            if (!config._isTest) {
                console.log(`${(0, commons_1.cinfo)(new Date().toISOString())} - "${req.method} ${req.url}" ${(0, commons_1.csuccess)(res.statusCode)}`);
            }
        }
        else {
            (_b = config._logger) === null || _b === void 0 ? void 0 : _b.error(`\nREQUEST: ${JSON.stringify(reqObject)}\nRESPONSE ERROR: ${res._error} ${(_c = res._error) === null || _c === void 0 ? void 0 : _c.stack}\n`);
            if (!config._isTest) {
                console.log(`${(0, commons_1.cinfo)(new Date().toISOString())} - "${req.method} ${req.url}" ${(0, commons_1.cerror)(res.statusCode || 500)} ${(0, commons_1.cerror)(res._error)} ${(0, commons_1.cerror)((_d = res._error) === null || _d === void 0 ? void 0 : _d.stack)}`);
            }
        }
    };
    next();
});
exports.injectorResponse = injectorResponse;
